with Ada.Strings.Fixed;
--  with Ada.Text_IO;

package body Broadcast_Stuff is

   use Ada.Strings.Unbounded;

   procedure Set_Port (Process_Entry : in out Process_Entry_Type;
                       Port : Positive) is
   begin
      Process_Entry.Port := Port;
   end Set_Port;

   procedure Set_Host (Process_Entry : in out Process_Entry_Type;
                       Host : String) is
   begin
      Process_Entry.Host := Ada.Strings.Unbounded.To_Unbounded_String (Host);
   end Set_Host;

   procedure Set_Name (Process_Entry : in out Process_Entry_Type;
                       Name : String) is
   begin
      Process_Entry.Name := To_Unbounded_String (Name);
   end Set_Name;

   function Get_Process (Directory : in out Broadcast_Stuff.Process_Directory.Directory_Type;
                         Kind : Process_Enum;
                         Name : String;
                         Host_Name : String;
                         Watchdog : Natural := 5) return String is
   begin
      for I in 0 .. Watchdog loop
         --  Ada.Text_IO.Put_Line ("watch dog" & I'Img);
         declare
            Processes : constant Process_Directory.Directory_Entry_Vectors.Vector :=
              Directory.Get_Entries (Kind);
         begin
            --  Ada.Text_IO.Put_Line ("process nb" & Processes.Length'Img);
            for A_Process of Processes loop
               if A_Process.Name = Name and A_Process.Host = Host_Name then
                  declare
                     Port_String : constant String := A_Process.Port'Img;
                  begin
                     return "http://" & Host_Name & ":" &
                       Ada.Strings.Fixed.Tail (Port_String, Port_String'Length - 1);
                  end;
               end if;
            end loop;
            Directory.Ask_For (Kind);
            delay 0.5;
         end;
      end loop;
      raise Process_Not_Found with Kind'Img & " named " & Name & " not found";
   end Get_Process;

end Broadcast_Stuff;
