with Ada.Text_IO;

pragma Warnings (Off);
with System.Tasking;
pragma Warnings (On);

package body Utiles_Task is

   task body Terminate_Task is
      C : Character;
   begin
      loop
         Ada.Text_IO.Get_Immediate (C);
         exit when C = 'Q' or C = 'q';
      end loop;
      Protected_Object.Stop;
   end Terminate_Task;

   protected body Task_Communication is
      procedure Stop is
      begin
         To_Stop := True;
         Ada.Text_IO.Put_Line ("task communication stop receive");
      end Stop;
      entry Can_Stop when To_Stop is
      begin
         Ada.Text_IO.Put_Line ("check stop validated");
      end Can_Stop;
      function Stop_Enabled return Boolean is
      begin
         return To_Stop;
      end Stop_Enabled;
   end Task_Communication;

   procedure Display_Tasks is
      use System.Tasking;
      C : Task_Id;
   begin
      C := All_Tasks_List;
      loop
         exit when C = null;
         Ada.Text_IO.Put_Line (C.Common.State'Img & " " & C.Common.Task_Image (1 .. C.Common.Task_Image_Len));
         C := C.Common.All_Tasks_Link;
      end loop;
   end Display_Tasks;

end Utiles_Task;
