
--  wsdl2aws SOAP Generator v2.3.1
--
--  AWS 3.2.0w - SOAP 1.5.0
--  This file was generated on Thursday 11 September 2014 at 14:47:15
--
--  $ wsdl2aws -noskel dcod_ctl.wsdl

pragma Warnings (Off);

with SOAP.Client;
pragma Elaborate_All (SOAP.Client);
with SOAP.Message.Payload;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Message);
pragma Elaborate_All (SOAP.Message.Payload);
with SOAP.Message.Response;
pragma Elaborate_All (SOAP.Message.Response);
with SOAP.Name_Space;
pragma Elaborate_All (SOAP.Name_Space);
with SOAP.Parameters;
pragma Elaborate_All (SOAP.Parameters);
with SOAP.Utils;
pragma Elaborate_All (SOAP.Utils);

package body Dcod_Ctl_Service.Client is

   use SOAP.Types;
   use type SOAP.Parameters.List;

   pragma Style_Checks (Off);

   --------------------
   -- Request_Server --
   --------------------

   procedure Request_Server
     (Connection : AWS.Client.HTTP_Connection;
      Name        : String;
      Buffer_Name : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name")
         & SOAP.Types.S (Buffer_Name, "Buffer_Name");
      Payload := SOAP.Message.Payload.Build
        ("Request_Server", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Ctl_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Request_Server", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Request_Server;

   procedure Request_Server
     (Name        : String;
      Buffer_Name : String;
      Endpoint    : String := Dcod_Ctl_Service.URL;
      Timeouts    : AWS.Client.Timeouts_Values := Dcod_Ctl_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Request_Server (Connection, Name, Buffer_Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Request_Server;

   -------------------
   -- Request_Client --
   -------------------

   procedure Request_Client
     (Connection : AWS.Client.HTTP_Connection;
      Name        : String;
      Buffer_Name : String;
      Server_Name : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name")
         & SOAP.Types.S (Buffer_Name, "Buffer_Name")
            & SOAP.Types.S (Server_Name, "Server_Name");
      Payload := SOAP.Message.Payload.Build
        ("Request_Client", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Ctl_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Request_Client", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Request_Client;

   procedure Request_Client
     (Name        : String;
      Buffer_Name : String;
      Server_Name : String;
      Endpoint    : String := Dcod_Ctl_Service.URL;
      Timeouts    : AWS.Client.Timeouts_Values := Dcod_Ctl_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Request_Client (Connection, Name, Buffer_Name, Server_Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Request_Client;

   -------------------
   -- Release_Server --
   -------------------

   procedure Release_Server
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Release_Server", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Ctl_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Release_Server", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Release_Server;

   procedure Release_Server
     (Name     : String;
      Endpoint : String := Dcod_Ctl_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Ctl_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Release_Server (Connection, Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Release_Server;

   ------------------
   -- Release_Client --
   ------------------

   procedure Release_Client
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Release_Client", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Ctl_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Release_Client", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Release_Client;

   procedure Release_Client
     (Name     : String;
      Endpoint : String := Dcod_Ctl_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Ctl_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Release_Client (Connection, Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Release_Client;

   ------------------
   -- Server_Exist --
   ------------------

   function Server_Exist
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
      return Boolean
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Server_Exist", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Ctl_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Server_Exist", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant Boolean
                 := SOAP.Parameters.Get (R_Param, "Result");
            begin
               return Result;
            end;
         end if;
      end;
   end Server_Exist;

   function Server_Exist
     (Name     : String;
      Endpoint : String := Dcod_Ctl_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Ctl_Service.Timeouts)
      return Boolean
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant Boolean :=
                    Server_Exist (Connection, Name);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Server_Exist;

   -----------------
   -- Client_Exist --
   -----------------

   function Client_Exist
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
      return Boolean
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Client_Exist", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Ctl_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Client_Exist", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant Boolean
                 := SOAP.Parameters.Get (R_Param, "Result");
            begin
               return Result;
            end;
         end if;
      end;
   end Client_Exist;

   function Client_Exist
     (Name     : String;
      Endpoint : String := Dcod_Ctl_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Ctl_Service.Timeouts)
      return Boolean
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant Boolean :=
                    Client_Exist (Connection, Name);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Client_Exist;

end Dcod_Ctl_Service.Client;
