
--  wsdl2aws SOAP Generator v2.3.0
--
--  AWS 3.0.0 - SOAP 1.5.0
--  This file was generated on Wednesday 27 March 2013 at 14:37:52
--
--  $ wsdl2aws -noskel wsdl/dcod_pmh.wsdl

pragma Warnings (Off);

with SOAP.Client;
pragma Elaborate_All (SOAP.Client);
with SOAP.Message.Payload;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Message);
pragma Elaborate_All (SOAP.Message.Payload);
with SOAP.Message.Response;
pragma Elaborate_All (SOAP.Message.Response);
with SOAP.Name_Space;
pragma Elaborate_All (SOAP.Name_Space);
with SOAP.Parameters;
pragma Elaborate_All (SOAP.Parameters);
with SOAP.Utils;
pragma Elaborate_All (SOAP.Utils);

package body Dcod_Pmh_Service.Client is

   use SOAP.Types;
   use type SOAP.Parameters.List;

   pragma Style_Checks (Off);

   -------------------
   -- Provide_Buffer --
   -------------------

   procedure Provide_Buffer
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String;
      Size       : Integer;
      Depth      : Integer)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name")
         & SOAP.Types.I (Size, "Size")
            & SOAP.Types.I (Depth, "Depth");
      Payload := SOAP.Message.Payload.Build
        ("Provide_Buffer", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Provide_Buffer", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Provide_Buffer;

   procedure Provide_Buffer
     (Name     : String;
      Size     : Integer;
      Depth    : Integer;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Provide_Buffer (Connection, Name, Size, Depth);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Provide_Buffer;

   ------------------
   -- Reset_Buffer --
   ------------------

   procedure Reset_Buffer
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Reset_Buffer", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Reset_Buffer", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Reset_Buffer;

   procedure Reset_Buffer
     (Name     : String;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Reset_Buffer (Connection, Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Reset_Buffer;

   ------------------
   -- Request_Buffer --
   ------------------

   procedure Request_Buffer
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Request_Buffer", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Request_Buffer", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Request_Buffer;

   procedure Request_Buffer
     (Name     : String;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Request_Buffer (Connection, Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Request_Buffer;

   -------------------
   -- Delete_Buffer --
   -------------------

   procedure Delete_Buffer
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Delete_Buffer", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Delete_Buffer", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Delete_Buffer;

   procedure Delete_Buffer
     (Name     : String;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Delete_Buffer (Connection, Name);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Delete_Buffer;

   ----------------
   -- Set_Policy --
   ----------------

   procedure Set_Policy
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String;
      Policy     : Policy_Type_Type;
      Value      : Boolean)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name")
         & SOAP.Types.E (Types.Image (Policy), "Policy_Type", "Policy")
            & SOAP.Types.B (Value, "Value");
      Payload := SOAP.Message.Payload.Build
        ("Set_Policy", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Set_Policy", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Set_Policy;

   procedure Set_Policy
     (Name     : String;
      Policy   : Policy_Type_Type;
      Value    : Boolean;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Set_Policy (Connection, Name, Policy, Value);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Set_Policy;

   --------------
   -- Set_Mode --
   --------------

   procedure Set_Mode
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String;
      Mode       : Mode_Type_Type;
      Value      : Boolean)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name")
         & SOAP.Types.E (Types.Image (Mode), "Mode_Type", "Mode")
            & SOAP.Types.B (Value, "Value");
      Payload := SOAP.Message.Payload.Build
        ("Set_Mode", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Set_Mode", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Set_Mode;

   procedure Set_Mode
     (Name     : String;
      Mode     : Mode_Type_Type;
      Value    : Boolean;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Set_Mode (Connection, Name, Mode, Value);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Set_Mode;

   ---------------
   -- Get_State --
   ---------------

   function Get_State
     (Connection : AWS.Client.HTTP_Connection)
      return String
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      Payload := SOAP.Message.Payload.Build
        ("Get_State", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Get_State", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant String
                 := SOAP.Parameters.Get (R_Param, "Result");
            begin
               return Result;
            end;
         end if;
      end;
   end Get_State;

   function Get_State
     (Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
      return String
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant String :=
                    Get_State (Connection);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Get_State;

   ----------------------
   -- Get_Buffer_State --
   ----------------------

   function Get_Buffer_State
     (Connection : AWS.Client.HTTP_Connection;
      Name       : String)
      return String
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Name, "Name");
      Payload := SOAP.Message.Payload.Build
        ("Get_Buffer_State", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Pmh_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Get_Buffer_State", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant String
                 := SOAP.Parameters.Get (R_Param, "Result");
            begin
               return Result;
            end;
         end if;
      end;
   end Get_Buffer_State;

   function Get_Buffer_State
     (Name     : String;
      Endpoint : String := Dcod_Pmh_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Pmh_Service.Timeouts)
      return String
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant String :=
                    Get_Buffer_State (Connection, Name);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Get_Buffer_State;

end Dcod_Pmh_Service.Client;
