package body Data_Transport.Socket_Utilities is

   procedure Receive (Socket : GNAT.Sockets.Socket_Type;
                      Data : out Ada.Streams.Stream_Element_Array) is
      use type Ada.Streams.Stream_Element_Offset;
      First : Ada.Streams.Stream_Element_Offset := Data'First;
      Index : Ada.Streams.Stream_Element_Offset := First - 1;
      Max : constant Ada.Streams.Stream_Element_Offset := Data'Last;
   begin
      loop
         GNAT.Sockets.Receive_Socket (Socket, Data (First .. Max), Index);
         exit when Index < First or else Index = Max;
         First := Index + 1;
      end loop;
   end Receive;

   procedure Send (Socket : GNAT.Sockets.Socket_Type;
                   Data : Ada.Streams.Stream_Element_Array) is
      use type Ada.Streams.Stream_Element_Offset;
      First : Ada.Streams.Stream_Element_Offset := Data'First;
      Index : Ada.Streams.Stream_Element_Offset := First - 1;
      Max : constant Ada.Streams.Stream_Element_Offset := Data'Last;
      use GNAT.Sockets;
   begin
      loop
         Send_Socket (Socket, Data (First .. Max), Index);
         exit when Index < First or else Index = Max;
         First := Index + 1;
      end loop;
   end Send;

end Data_Transport.Socket_Utilities;
