with SOAP.Message.Response.Error;

with Dcod_Ctl_Service.Server;
pragma Elaborate_All (Dcod_Ctl_Service.Server);
with DCOD.Ctl.Services;

package body DCOD.Ctl.Soap_Cb is

   function Request_Server_Cb is new
     Dcod_Ctl_Service.Server.Request_Server_CB
     (DCOD.Ctl.Services.Request_Server);
   function Request_Client_Cb is new
     Dcod_Ctl_Service.Server.Request_Client_CB
     (DCOD.Ctl.Services.Request_Client);
   function Release_Server_Cb is new
     Dcod_Ctl_Service.Server.Release_Server_CB
     (DCOD.Ctl.Services.Release_Server);
   function Release_Client_Cb is new
     Dcod_Ctl_Service.Server.Release_Client_CB
     (DCOD.Ctl.Services.Release_Client);
   function Server_Exist_Cb is new
     Dcod_Ctl_Service.Server.Server_Exist_CB
     (DCOD.Ctl.Services.Server_Exist);
   function Client_Exist_Cb is new
     Dcod_Ctl_Service.Server.Client_Exist_CB
     (DCOD.Ctl.Services.Client_Exist);

   function Callback (SOAPAction : String;
                      Payload    : SOAP.Message.Payload.Object;
                      Request    : AWS.Status.Data)
                     return AWS.Response.Data is
   begin
      if SOAPAction = "Request_Server" then
         return Request_Server_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Request_Client" then
         return Request_Client_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Release_Server" then
         return Release_Server_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Release_Client" then
         return Release_Client_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Server_Exist" then
         return Server_Exist_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Client_Exist" then
         return Client_Exist_Cb (SOAPAction, Payload, Request);
      else
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Wrong SOAP action " & SOAPAction));
      end if;
   end Callback;

end DCOD.Ctl.Soap_Cb;
