package body Buffers.Shared is

   procedure Find_And_Remove (Queue_Vector : in out Queue_Vectors.Vector;
                              Uuid : Uuid_Image_Type;
                              Queue : out Unique_Queue_Type) is
      Cursor : Queue_Vectors.Cursor;
      use type Queue_Vectors.Cursor;
   begin
      Cursor := Queue_Vectors.First (Queue_Vector);
      loop
         exit when Cursor = Queue_Vectors.No_Element;
         if Queue_Vectors.Element (Cursor).Uuid = Uuid then
            Queue := Queue_Vectors.Element (Cursor);
            Queue_Vectors.Delete (Queue_Vector, Cursor);
            return;
         end if;
         Cursor := Queue_Vectors.Next (Cursor);
      end loop;
      raise Uuid_Not_Found;
   end Find_And_Remove;

   function Find (Queue_Vector : Queue_Vectors.Vector;
                  Uuid : Uuid_Image_Type) return Unique_Queue_Type is
   begin
      for Queue of Queue_Vector loop
         if Queue.Uuid = Uuid then
            return Queue;
         end if;
      end loop;
      raise Uuid_Not_Found;
   end Find;

end Buffers.Shared;
