with Common_Types.String_Vectors;
with Ada.Strings.Unbounded;
with AWS.MIME;
with Buffers.Shell;
with P42.Html_Utils;

with DCOD.Environment;

package body DCOD.Pmh.Http is

   use Ada.Strings.Unbounded;

   function Callback (Request : AWS.Status.Data) return AWS.Response.Data is
      URI : constant String := AWS.Status.URI (Request);
      Page : P42.Html_Utils.T_Page_Html;
   begin
      if URI = "/" then
         Page.Head (Title => "POSIX_MEMORY_HANDLER",
                    CSS_URI => "/css");
         declare
            Names : constant Common_Types.String_Vectors.Vector :=
              Buffers.Shell.Memory_Handler.Get_Buffer_Names;
            Answer : Ada.Strings.Unbounded.Unbounded_String;
            Count : Integer := 1;
         begin
            if Names.Is_Empty then
               Page.Append_Code ("<div class='entete_pmh'><br/><h3>NO BUFFER'S LIST !</h3>");
               Page.Append_Code ("<br/><p class='test'>No buffer? Get out ! ......</p>");
               Page.Append_Code ("</div>");
            else
               Page.Append_Code ("<div class='entete_pmh'>");
               Page.Append_Code ("<h3>Buffer List<h3>");
               Page.Append_Code ("</div>");
               Page.Append_Code ("<div class='corps_page_pmh'>");
               Page.Append_Code ("<table class='desc_pmh'>");
               Page.Append_Code ("<tr>");
               Page.Append_Code ("<th class='Colonnes_pmh'>");
               Page.Append_Code ("Numero du Buffer");
               Page.Append_Code ("</th>");
               Page.Append_Code ("<th class='Colonnes_pmh'>");
               Page.Append_Code ("Nom du Buffer");
               Page.Append_Code ("</th>");
               Page.Append_Code ("<th class='Colonnes_pmh'>");
               Page.Append_Code ("Taille du Buffer");
               Page.Append_Code ("</th>");
               Page.Append_Code ("<th class='Colonnes_pmh'>");
               Page.Append_Code ("");
               Page.Append_Code ("</th>");
               Page.Append_Code ("</tr>");
               for Name of Names loop
                  Page.Append_Code ("<tr>");
                  Page.Append_Code ("<td class='affiche_pmh'>Buffer");
                  Page.Append_Code (Integer'Image (Count));
                  Count := Count + 1;
                  Page.Append_Code ("<td class='td_pmh'>");
                  Page.Append_Code (Answer & ASCII.LF & Name);
                  Page.Append_Code ("</td>");
                  Page.Append_Code ("<td class='td_pmh'>");
                  Page.Append_Code (Buffers.Shell.Memory_Handler.Get_Buffer_Size (Name)'Img);
                  Page.Append_Code ("</td>");
                  Page.Append_Code ("</tr>");
               end loop;
               Page.Append_Code ("</table>");
               Page.Append_Code ("</div>");
               Page.Append_Code ("<br/>");
               Page.Append_Code ("<div class='piedPage_pmh'>");
               Page.Append_Code ("<h2>Support !</h2>");
               Page.Append_Code ("</div>");
            end if;
            return AWS.Response.Build ("text/html", Page.Return_Page);
         end;
      elsif URI = "/css" then
         return AWS.Response.File (AWS.MIME.Text_CSS, DCOD.Environment.CSS_Directory.all & "/dcod_global.css");
      end if;
      return AWS.Response.Build ("text/html",
                                 "<p>Empty page</p>" & ASCII.LF &
                                   "<p>Unknown Request : " & URI & "</p>");
   end Callback;

end DCOD.Pmh.Http;
