with DCOD.Pmh.Real_Handler;

package body DCOD.Pmh.Services is

   use Real_Handler;

   procedure Provide_Buffer (Name : String;
                             Size : Positive := 65_536;
                             Depth : Positive := 3) is
   begin
      Memory_Handler_Task.Provide_Buffer (Name,
                                          Common_Types.Buffer_Size_Type (Size),
                                          Depth);
   end Provide_Buffer;

   procedure Request_Buffer (Name : String) is
   begin
      Memory_Handler_Task.Request_Buffer (Name);
   end Request_Buffer;

   procedure Reset_Buffer (Name : String) is
   begin
      Memory_Handler_Task.Reset_Buffer (Name);
   end Reset_Buffer;

   procedure Set_Policy (Name : String;
                         Policy : Common_Types.Policy_Type;
                         Value : Boolean) is
   begin
      Memory_Handler_Task.Set_Policy (Name, Policy, Value);
   end Set_Policy;

   procedure Set_Mode (Name : String;
                         Mode : Common_Types.Mode_Type;
                         Value : Boolean) is
   begin
      Memory_Handler_Task.Set_Mode (Name, Mode, Value);
   end Set_Mode;

   procedure Delete_Buffer (Name : String) is
   begin
      Memory_Handler_Task.Delete_Buffer (Name);
   end Delete_Buffer;

   function Get_State return String is
   begin
      return Real_Handler.Get_State;
   end Get_State;

   function Get_Buffer_State (Name : String) return String is
   begin
      return Real_Handler.Get_Buffer_State (Name);
   end Get_Buffer_State;

end DCOD.Pmh.Services;
