with Common_Types;

package DCOD.Pmh.Services is

   --  This function create the shared buffer. It needs a name, a size (in
   --  bytes) and a depth. The default depth is 3 and the default size is
   --  65536 bytes.
   procedure Provide_Buffer (Name : String;
                             Size : Positive := 65_536;
                             Depth : Positive := 3);
   procedure Request_Buffer (Name : String);
   --  This procedure reset a buffer.
   procedure Reset_Buffer (Name : String);
   --  This procedure delete a buffer.
   procedure Delete_Buffer (Name : String);

   --  This procedure enable or disable a policy for the buffer referenced by
   --  Name.
   procedure Set_Policy (Name : String;
                         Policy : Common_Types.Policy_Type;
                         Value : Boolean);

   --  This procedure enable or disable a mode for the buffer referenced by
   --  Name.
   procedure Set_Mode (Name : String;
                       Mode : Common_Types.Mode_Type;
                       Value : Boolean);

   --  This function returns, as an XML string, the state of all the buffers
   --  Posix Manager Handler contains.
   function Get_State return String;

   --  This function returns, as an XML string, the state of the buffer named
   --  Name.
   function Get_Buffer_State (Name : String) return String;

end DCOD.Pmh.Services;
