with SOAP.Message.Response.Error;

with Dcod_Pmh_Service.Server;
pragma Elaborate_All (Dcod_Pmh_Service.Server);
with DCOD.Pmh.Services;

package body DCOD.Pmh.Soap_Cb is

   function Provide_Buffer_Cb is new
     Dcod_Pmh_Service.Server.Provide_Buffer_CB
     (DCOD.Pmh.Services.Provide_Buffer);
   function Request_Buffer_Cb is new
     Dcod_Pmh_Service.Server.Request_Buffer_CB
     (DCOD.Pmh.Services.Request_Buffer);
   function Reset_Buffer_Cb is new
     Dcod_Pmh_Service.Server.Reset_Buffer_CB
     (DCOD.Pmh.Services.Reset_Buffer);
   function Delete_Buffer_Cb is new
     Dcod_Pmh_Service.Server.Delete_Buffer_CB
     (DCOD.Pmh.Services.Delete_Buffer);
   function Set_Policy_Cb is new
     Dcod_Pmh_Service.Server.Set_Policy_CB
     (DCOD.Pmh.Services.Set_Policy);
   function Set_Mode_Cb is new
     Dcod_Pmh_Service.Server.Set_Mode_CB
     (DCOD.Pmh.Services.Set_Mode);
   function Get_State_Cb is new
     Dcod_Pmh_Service.Server.Get_State_CB
     (DCOD.Pmh.Services.Get_State);
   function Get_Buffer_State_Cb is new
     Dcod_Pmh_Service.Server.Get_Buffer_State_CB
     (DCOD.Pmh.Services.Get_Buffer_State);

   function Callback (SOAPAction : String;
                      Payload    : SOAP.Message.Payload.Object;
                      Request    : AWS.Status.Data)
                     return AWS.Response.Data is
   begin
      if SOAPAction = "Provide_Buffer" then
         return Provide_Buffer_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Request_Buffer" then
         return Request_Buffer_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Reset_Buffer" then
         return Reset_Buffer_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Delete_Buffer" then
         return Delete_Buffer_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Set_Policy" then
         return Set_Policy_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Set_Mode" then
         return Set_Mode_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Get_State" then
         return Get_State_Cb (SOAPAction, Payload, Request);
      elsif SOAPAction = "Get_Buffer_State" then
         return Get_Buffer_State_Cb (SOAPAction, Payload, Request);
      else
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Wrong SOAP action " & SOAPAction));
      end if;
   end Callback;

end DCOD.Pmh.Soap_Cb;
