
--  wsdl2aws SOAP Generator v2.3.0
--
--  AWS 3.0.0 - SOAP 1.5.0
--  This file was generated on Wednesday 27 March 2013 at 14:37:52
--
--  $ wsdl2aws -f -nostub wsdl/dcod_pmh.wsdl

with Ada.Exceptions;

with SOAP.Message.Response.Error;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Message);
pragma Elaborate_All (SOAP.Message.Response);
pragma Elaborate_All (SOAP.Message.Response.Error);
with SOAP.Parameters;
pragma Elaborate_All (SOAP.Parameters);
with SOAP.Utils;
pragma Elaborate_All (SOAP.Utils);

package body Dcod_Pmh_Service.Server is

   use Ada.Exceptions;

   use SOAP.Types;
   use type SOAP.Parameters.List;

   pragma Warnings (Off);
   --  Suppress wrong warnings generated by GNAT (fixed in 3.17)

   pragma Style_Checks (Off);

   ----------------------
   -- Provide_Buffer_CB --
   ----------------------

   function Provide_Buffer_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Provide_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Provide_Buffer, "
                 & "Provide_Buffer expected."));
      end if;

      if Proc_Name /= "Provide_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Provide_Buffer, "
                 & "Provide_Buffer expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name  : constant String
           := SOAP.Parameters.Get (Params, "Name");
         Size  : constant Integer
           := SOAP.Parameters.Get (Params, "Size");
         Depth : constant Integer
           := SOAP.Parameters.Get (Params, "Depth");
      begin
         Provide_Buffer                (Name,
                 Size,
                 Depth);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Provide_Buffer ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Provide_Buffer ("
                 & Exception_Message (O) & ")"));
   end Provide_Buffer_CB;

   ---------------------
   -- Reset_Buffer_CB --
   ---------------------

   function Reset_Buffer_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Reset_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Reset_Buffer, "
                 & "Reset_Buffer expected."));
      end if;

      if Proc_Name /= "Reset_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Reset_Buffer, "
                 & "Reset_Buffer expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name : constant String
           := SOAP.Parameters.Get (Params, "Name");
      begin
         Reset_Buffer                (Name);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Reset_Buffer ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Reset_Buffer ("
                 & Exception_Message (O) & ")"));
   end Reset_Buffer_CB;

   ---------------------
   -- Request_Buffer_CB --
   ---------------------

   function Request_Buffer_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Request_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Request_Buffer, "
                 & "Request_Buffer expected."));
      end if;

      if Proc_Name /= "Request_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Request_Buffer, "
                 & "Request_Buffer expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name : constant String
           := SOAP.Parameters.Get (Params, "Name");
      begin
         Request_Buffer                (Name);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Request_Buffer ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Request_Buffer ("
                 & Exception_Message (O) & ")"));
   end Request_Buffer_CB;

   ----------------------
   -- Delete_Buffer_CB --
   ----------------------

   function Delete_Buffer_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Delete_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Delete_Buffer, "
                 & "Delete_Buffer expected."));
      end if;

      if Proc_Name /= "Delete_Buffer" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Delete_Buffer, "
                 & "Delete_Buffer expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name : constant String
           := SOAP.Parameters.Get (Params, "Name");
      begin
         Delete_Buffer                (Name);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Delete_Buffer ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Delete_Buffer ("
                 & Exception_Message (O) & ")"));
   end Delete_Buffer_CB;

   -------------------
   -- Set_Policy_CB --
   -------------------

   function Set_Policy_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Set_Policy" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Set_Policy, "
                 & "Set_Policy expected."));
      end if;

      if Proc_Name /= "Set_Policy" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Set_Policy, "
                 & "Set_Policy expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name   : constant String
           := SOAP.Parameters.Get (Params, "Name");
         Policy : constant Policy_Type_Type
           := Policy_Type_Type'Value
                (SOAP.Utils.Get (SOAP.Parameters.Argument (Params, "Policy")));
         Value  : constant Boolean
           := SOAP.Parameters.Get (Params, "Value");
      begin
         Set_Policy                (Name,
                 Policy,
                 Value);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Set_Policy ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Set_Policy ("
                 & Exception_Message (O) & ")"));
   end Set_Policy_CB;

   -----------------
   -- Set_Mode_CB --
   -----------------

   function Set_Mode_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Set_Mode" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Set_Mode, "
                 & "Set_Mode expected."));
      end if;

      if Proc_Name /= "Set_Mode" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Set_Mode, "
                 & "Set_Mode expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name  : constant String
           := SOAP.Parameters.Get (Params, "Name");
         Mode  : constant Mode_Type_Type
           := Mode_Type_Type'Value
                (SOAP.Utils.Get (SOAP.Parameters.Argument (Params, "Mode")));
         Value : constant Boolean
           := SOAP.Parameters.Get (Params, "Value");
      begin
         Set_Mode                (Name,
                 Mode,
                 Value);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Set_Mode ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Set_Mode ("
                 & Exception_Message (O) & ")"));
   end Set_Mode_CB;

   ------------------
   -- Get_State_CB --
   ------------------

   function Get_State_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Get_State" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Get_State, "
                 & "Get_State expected."));
      end if;

      if Proc_Name /= "Get_State" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Get_State, "
                 & "Get_State expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Result : constant String
           := Get_State;
      begin
         R_Params :=
           +SOAP.Types.S (Result, "Result");
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Get_State ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Get_State ("
                 & Exception_Message (O) & ")"));
   end Get_State_CB;

   -------------------------
   -- Get_Buffer_State_CB --
   -------------------------

   function Get_Buffer_State_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Get_Buffer_State" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Get_Buffer_State, "
                 & "Get_Buffer_State expected."));
      end if;

      if Proc_Name /= "Get_Buffer_State" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Get_Buffer_State, "
                 & "Get_Buffer_State expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Name : constant String
           := SOAP.Parameters.Get (Params, "Name");
         Result : constant String
           := Get_Buffer_State
                (Name);
      begin
         R_Params :=
           +SOAP.Types.S (Result, "Result");
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Get_Buffer_State ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Get_Buffer_State ("
                 & Exception_Message (O) & ")"));
   end Get_Buffer_State_CB;

end Dcod_Pmh_Service.Server;
