with McKae.XML.EZ_Out.String_Stream;

function DCOD.Interfaces.Data_Flow_Handler.To_Xml
  (Objects : Data_Flow_Handler_Array) return String is
   use McKae.XML.EZ_Out.String_Stream.String_Buffering;
   use McKae.XML.EZ_Out.String_Stream.XML_String_Buffer;
   Xml_Buffer : String_Buffer;
begin
   Current_Format := McKae.XML.EZ_Out.Continuous_Stream;
   Start_Element (Xml_Buffer, "result",
                  ("cmd" = "get", "status" = "OK"));
   Start_Element (Xml_Buffer, "data",
                  ("sub_system_number" = Objects'Length,
                   "type" = "string",
                   "name" = "sub_systems"));
   if Objects'Length = 0 then
      Output_Element (Xml_Buffer, "value", "");
   else
      for I in Objects'Range loop
         Output_Element (Xml_Buffer, "value", Objects (I).Get_Name);
      end loop;
   end if;
   End_Element (Xml_Buffer, "data");
   End_Element (Xml_Buffer, "result");
   declare
      String_To_Return : constant String := Get_String (Xml_Buffer);
   begin
      Full_Clear (Xml_Buffer);
      return String_To_Return;
   end;
end DCOD.Interfaces.Data_Flow_Handler.To_Xml;
