with DCOD.Interfaces.Data_Flow_Handler;

with Events_Receivers;

package DCOD.Services is
   pragma Remote_Call_Interface;

   --  This procedure should be used only to suscribe object that are not
   --  belonging to PMH, nor CTL, nor Narval and nor ENX.
   procedure Subscribe_Object (Object : Interfaces.DCOD_Object_Access);
   --  This procedure unsubscribe an object subcribed with the Subscribe_Object
   --  procedure.
   procedure Unsubscribe_Object (Object : Interfaces.DCOD_Object_Access);
   --  This function returns all the Objects presents in the DCOD environment.
   function Get_Objects return Interfaces.DCOD_Object_Array;

   --  This procedure should be used to suscribe a Data Flow Handler.
   procedure Subscribe_Data_Flow_Handler
     (Object : Interfaces.Data_Flow_Handler.Data_Flow_Handler_Access);
   --  This procedure unsubscribe a data flow handler subcribed with the
   --  Subscribe_Data_Flow_Handler procedure.
   procedure Unsubscribe_Data_Flow_Handler
     (Object : Interfaces.Data_Flow_Handler.Data_Flow_Handler_Access);
   --  This function returns all the Data Flow Handlers that are already
   --  suscribed.
   function Get_Data_Flow_Handlers
     return Interfaces.Data_Flow_Handler.Data_Flow_Handler_Array;
   --  This function returns the fat pointer pointed by Name.
   function Get_Data_Flow_Handler (Name : String) return
     Interfaces.Data_Flow_Handler.Data_Flow_Handler_Access;

   --  This function returns true if the system have to end.
   function Is_This_The_End return Boolean;
   --  This procedure will end all the system if no remote types are
   --  registered. If the system can go to end quietly, the procedure will
   --  raise Unable_To_End_Service.
   procedure End_Service (Force : Boolean);
   Unable_To_End_Service : exception;

   --  This procedure should be used to suscribe an event receiver compatible
   --  with the log4ada library.
   procedure Suscribe_Event_Receiver
     (Events_Receiver : Events_Receivers.Events_Receivers_Class_Access);
   --  This function enable to retreive a fat pointer to the central log
   --  facility. If there isn't any event receiver available, it raises
   --  the No_Event_Receiver exception.
   function Get_Event_Receiver return
     Events_Receivers.Events_Receivers_Class_Access;
   No_Event_Receiver : exception;

end DCOD.Services;
