
--  wsdl2aws SOAP Generator v2.3.0
--
--  AWS 3.1.0w - SOAP 1.5.0
--  This file was generated on Thursday 02 May 2013 at 15:55:52
--
--  $ wsdl2aws -cb -types Common_Types.Strings -spec Dcod_Process_Launcher
--  ../wsdl/dcod_launcher.wsdl

pragma Warnings (Off);

with SOAP.Client;
pragma Elaborate_All (SOAP.Client);
with SOAP.Message.Payload;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Message);
pragma Elaborate_All (SOAP.Message.Payload);
with SOAP.Message.Response;
pragma Elaborate_All (SOAP.Message.Response);
with SOAP.Name_Space;
pragma Elaborate_All (SOAP.Name_Space);
with SOAP.Parameters;
pragma Elaborate_All (SOAP.Parameters);
with SOAP.Utils;
pragma Elaborate_All (SOAP.Utils);

package body Dcod_Process_Launcher_Service.Client is

   use SOAP.Types;
   use type SOAP.Parameters.List;

   pragma Style_Checks (Off);

   ------------
   -- Launch --
   ------------

   procedure Launch
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String;
      Parameters   : String_Couple_Array_Type)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Process_Name, "Process_Name")
         & A (To_Object_Set (Parameters), "Parameters");
      Payload := SOAP.Message.Payload.Build
        ("Launch", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Process_Launcher_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Launch", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Launch;

   procedure Launch
     (Process_Name : String;
      Parameters   : String_Couple_Array_Type;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Launch (Connection, Process_Name, Parameters);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Launch;

   -------------------------
   -- Get_Executable_List --
   -------------------------

   function Get_Executable_List
     (Connection : AWS.Client.HTTP_Connection;
      Directory_Name : String)
      return Get_Executable_List_Result
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Directory_Name, "Directory_Name");
      Payload := SOAP.Message.Payload.Build
        ("Get_Executable_List", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Process_Launcher_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Get_Executable_List", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant Get_Executable_List_Result
                 := To_String_Array_Type
                 (V (SOAP_Array'(SOAP.Parameters.Get (R_Param, "Result"))));
            begin
               return Result;
            end;
         end if;
      end;
   end Get_Executable_List;

   function Get_Executable_List
     (Directory_Name : String;
      Endpoint       : String := Dcod_Process_Launcher_Service.URL;
      Timeouts       : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
      return Get_Executable_List_Result
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant Get_Executable_List_Result :=
                    Get_Executable_List (Connection, Directory_Name);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Get_Executable_List;

   ----------------------
   -- Get_Running_List --
   ----------------------

   function Get_Running_List
     (Connection : AWS.Client.HTTP_Connection)
      return Get_Running_List_Result
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      Payload := SOAP.Message.Payload.Build
        ("Get_Running_List", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Process_Launcher_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Get_Running_List", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant Get_Running_List_Result
                 := To_String_Couple_Array_Type
                 (V (SOAP_Array'(SOAP.Parameters.Get (R_Param, "Result"))));
            begin
               return Result;
            end;
         end if;
      end;
   end Get_Running_List;

   function Get_Running_List
     (Endpoint : String := Dcod_Process_Launcher_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
      return Get_Running_List_Result
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant Get_Running_List_Result :=
                    Get_Running_List (Connection);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Get_Running_List;

   --------------------
   -- Get_Properties --
   --------------------

   function Get_Properties
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String)
      return Get_Properties_Result
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Process_Name, "Process_Name");
      Payload := SOAP.Message.Payload.Build
        ("Get_Properties", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Process_Launcher_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Get_Properties", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         else
            declare
               Result : constant Get_Properties_Result
                 := To_String_Couple_Array_Type
                 (V (SOAP_Array'(SOAP.Parameters.Get (R_Param, "Result"))));
            begin
               return Result;
            end;
         end if;
      end;
   end Get_Properties;

   function Get_Properties
     (Process_Name : String;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
      return Get_Properties_Result
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      declare
         Result : constant Get_Properties_Result :=
                    Get_Properties (Connection, Process_Name);
      begin
         AWS.Client.Close (Connection);
         return Result;
      end;
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Get_Properties;

   ------------
   -- Remove --
   ------------

   procedure Remove
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String;
      Parameters   : String_Couple_Array_Type;
      Kill         : Boolean)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Process_Name, "Process_Name")
         & A (To_Object_Set (Parameters), "Parameters")
            & SOAP.Types.B (Kill, "Kill");
      Payload := SOAP.Message.Payload.Build
        ("Remove", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Process_Launcher_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Remove", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Remove;

   procedure Remove
     (Process_Name : String;
      Parameters   : String_Couple_Array_Type;
      Kill         : Boolean;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Remove (Connection, Process_Name, Parameters, Kill);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Remove;

   -------------------
   -- Remove_By_Pid --
   -------------------

   procedure Remove_By_Pid
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String;
      Pid          : Integer;
      Kill         : Boolean)
   is
      P_Set   : SOAP.Parameters.List;
      Payload : SOAP.Message.Payload.Object;
   begin
      --  Set parameters
      P_Set := +SOAP.Types.S (Process_Name, "Process_Name")
         & SOAP.Types.I (Pid, "Pid")
            & SOAP.Types.B (Kill, "Kill");
      Payload := SOAP.Message.Payload.Build
        ("Remove_By_Pid", P_Set,
         SOAP.Name_Space.Create ("tns", "http://soapaws/Dcod_Process_Launcher_def/"));

      declare
         Response : constant SOAP.Message.Response.Object'Class
           := SOAP.Client.Call
                (Connection, "Remove_By_Pid", Payload);
         R_Param  : constant SOAP.Parameters.List
           := SOAP.Message.Parameters (Response);
      begin
         if SOAP.Message.Response.Is_Error (Response) then
            raise SOAP.SOAP_Error with
               SOAP.Parameters.Get (R_Param, "faultstring");
         end if;
      end;
   end Remove_By_Pid;

   procedure Remove_By_Pid
     (Process_Name : String;
      Pid          : Integer;
      Kill         : Boolean;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
   is
      Connection : AWS.Client.HTTP_Connection;
   begin
      AWS.Client.Create
        (Connection, Endpoint,
         Persistent => False,
         Timeouts   => Timeouts);
      Remove_By_Pid (Connection, Process_Name, Pid, Kill);
      AWS.Client.Close (Connection);
   exception
      when others =>
         AWS.Client.Close (Connection);
         raise;
   end Remove_By_Pid;

end Dcod_Process_Launcher_Service.Client;
