
--  wsdl2aws SOAP Generator v2.3.0
--
--  AWS 3.1.0w - SOAP 1.5.0
--  This file was generated on Thursday 02 May 2013 at 15:55:52
--
--  $ wsdl2aws -cb -types Common_Types.Strings -spec Dcod_Process_Launcher
--  ../wsdl/dcod_launcher.wsdl

pragma Warnings (Off);

with Ada.Calendar;

with SOAP.Types;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Types);

with Dcod_Process_Launcher_Service.Types;

package Dcod_Process_Launcher_Service.Client is

   use Dcod_Process_Launcher_Service.Types;

   Connection : constant AWS.Client.HTTP_Connection;

   procedure Launch
     (Process_Name : String;
      Parameters   : String_Couple_Array_Type;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts);
   procedure Launch
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String;
      Parameters   : String_Couple_Array_Type);
   --  Raises SOAP.SOAP_Error if the procedure fails

   function Get_Executable_List
     (Directory_Name : String;
      Endpoint       : String := Dcod_Process_Launcher_Service.URL;
      Timeouts       : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
      return Get_Executable_List_Result;
   function Get_Executable_List
     (Connection : AWS.Client.HTTP_Connection;
      Directory_Name : String)
      return Get_Executable_List_Result;
   --  Raises SOAP.SOAP_Error if the procedure fails

   function Get_Running_List
     (Endpoint : String := Dcod_Process_Launcher_Service.URL;
      Timeouts : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
      return Get_Running_List_Result;
   function Get_Running_List
     (Connection : AWS.Client.HTTP_Connection)
      return Get_Running_List_Result;
   --  Raises SOAP.SOAP_Error if the procedure fails

   function Get_Properties
     (Process_Name : String;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts)
      return Get_Properties_Result;
   function Get_Properties
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String)
      return Get_Properties_Result;
   --  Raises SOAP.SOAP_Error if the procedure fails

   procedure Remove
     (Process_Name : String;
      Parameters   : String_Couple_Array_Type;
      Kill         : Boolean;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts);
   procedure Remove
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String;
      Parameters   : String_Couple_Array_Type;
      Kill         : Boolean);
   --  Raises SOAP.SOAP_Error if the procedure fails

   procedure Remove_By_Pid
     (Process_Name : String;
      Pid          : Integer;
      Kill         : Boolean;
      Endpoint     : String := Dcod_Process_Launcher_Service.URL;
      Timeouts     : AWS.Client.Timeouts_Values := Dcod_Process_Launcher_Service.Timeouts);
   procedure Remove_By_Pid
     (Connection : AWS.Client.HTTP_Connection;
      Process_Name : String;
      Pid          : Integer;
      Kill         : Boolean);
   --  Raises SOAP.SOAP_Error if the procedure fails

private

   Connection : constant AWS.Client.HTTP_Connection :=
                  AWS.Client.Create
                    (URL,
                     Timeouts   => Timeouts);

end Dcod_Process_Launcher_Service.Client;
