
--  wsdl2aws SOAP Generator v2.3.0
--
--  AWS 3.1.0w - SOAP 1.5.0
--  This file was generated on Thursday 02 May 2013 at 15:55:52
--
--  $ wsdl2aws -cb -types Common_Types.Strings -spec Dcod_Process_Launcher
--  ../wsdl/dcod_launcher.wsdl

with Ada.Exceptions;

with SOAP.Message.Response.Error;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Message);
pragma Elaborate_All (SOAP.Message.Response);
pragma Elaborate_All (SOAP.Message.Response.Error);
with SOAP.Parameters;
pragma Elaborate_All (SOAP.Parameters);
with SOAP.Utils;
pragma Elaborate_All (SOAP.Utils);

package body Dcod_Process_Launcher_Service.Server is

   use Ada.Exceptions;

   use SOAP.Types;
   use type SOAP.Parameters.List;

   pragma Warnings (Off);
   --  Suppress wrong warnings generated by GNAT (fixed in 3.17)

   pragma Style_Checks (Off);

   ---------------
   -- Launch_CB --
   ---------------

   function Launch_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Launch" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Launch, "
                 & "Launch expected."));
      end if;

      if Proc_Name /= "Launch" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Launch, "
                 & "Launch expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Process_Name : constant String
           := SOAP.Parameters.Get (Params, "Process_Name");
         Parameters_String_Couple_Array_Array : constant SOAP.Types.SOAP_Array
           := SOAP.Parameters.Get (Params, "Parameters");
         Parameters   : constant String_Couple_Array_Type
           := To_String_Couple_Array_Type (V (Parameters_String_Couple_Array_Array));
      begin
         Launch                (Process_Name,
                 Parameters);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Launch ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Launch ("
                 & Exception_Message (O) & ")"));
   end Launch_CB;

   ----------------------------
   -- Get_Executable_List_CB --
   ----------------------------

   function Get_Executable_List_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Get_Executable_List" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Get_Executable_List, "
                 & "Get_Executable_List expected."));
      end if;

      if Proc_Name /= "Get_Executable_List" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Get_Executable_List, "
                 & "Get_Executable_List expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Directory_Name : constant String
           := SOAP.Parameters.Get (Params, "Directory_Name");
         Result : constant Get_Executable_List_Result
           := Get_Executable_List
                (Directory_Name);
      begin
         R_Params :=
           +SOAP.Types.A (To_Object_Set (Result), "Result");
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Get_Executable_List ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Get_Executable_List ("
                 & Exception_Message (O) & ")"));
   end Get_Executable_List_CB;

   -------------------------
   -- Get_Running_List_CB --
   -------------------------

   function Get_Running_List_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Get_Running_List" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Get_Running_List, "
                 & "Get_Running_List expected."));
      end if;

      if Proc_Name /= "Get_Running_List" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Get_Running_List, "
                 & "Get_Running_List expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Result : constant Get_Running_List_Result
           := Get_Running_List;
      begin
         R_Params :=
           +SOAP.Types.A (To_Object_Set (Result), "Result");
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Get_Running_List ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Get_Running_List ("
                 & Exception_Message (O) & ")"));
   end Get_Running_List_CB;

   -----------------------
   -- Get_Properties_CB --
   -----------------------

   function Get_Properties_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Get_Properties" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Get_Properties, "
                 & "Get_Properties expected."));
      end if;

      if Proc_Name /= "Get_Properties" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Get_Properties, "
                 & "Get_Properties expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Process_Name : constant String
           := SOAP.Parameters.Get (Params, "Process_Name");
         Result : constant Get_Properties_Result
           := Get_Properties
                (Process_Name);
      begin
         R_Params :=
           +SOAP.Types.A (To_Object_Set (Result), "Result");
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Get_Properties ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Get_Properties ("
                 & Exception_Message (O) & ")"));
   end Get_Properties_CB;

   ---------------
   -- Remove_CB --
   ---------------

   function Remove_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Remove" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Remove, "
                 & "Remove expected."));
      end if;

      if Proc_Name /= "Remove" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Remove, "
                 & "Remove expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Process_Name : constant String
           := SOAP.Parameters.Get (Params, "Process_Name");
         Parameters_String_Couple_Array_Array : constant SOAP.Types.SOAP_Array
           := SOAP.Parameters.Get (Params, "Parameters");
         Parameters   : constant String_Couple_Array_Type
           := To_String_Couple_Array_Type (V (Parameters_String_Couple_Array_Array));
         Kill         : constant Boolean
           := SOAP.Parameters.Get (Params, "Kill");
      begin
         Remove                (Process_Name,
                 Parameters,
                 Kill);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Remove ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Remove ("
                 & Exception_Message (O) & ")"));
   end Remove_CB;

   ----------------------
   -- Remove_By_Pid_CB --
   ----------------------

   function Remove_By_Pid_CB
     (SOAPAction : String;
      Payload    : SOAP.Message.Payload.Object;
      Request    : AWS.Status.Data)
      return AWS.Response.Data
   is
      Proc_Name : constant String
        := SOAP.Message.Payload.Procedure_Name (Payload);
      Params    : constant SOAP.Parameters.List
        := SOAP.Message.Parameters (Payload);
      Response  : SOAP.Message.Response.Object;
      R_Params  : SOAP.Parameters.List;
   begin
      if SOAPAction /= "Remove_By_Pid" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "SOAPAction " & SOAPAction & " in Remove_By_Pid, "
                 & "Remove_By_Pid expected."));
      end if;

      if Proc_Name /= "Remove_By_Pid" then
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Found procedure " & Proc_Name & " in Remove_By_Pid, "
                 & "Remove_By_Pid expected."));
      end if;

      Response := SOAP.Message.Response.From (Payload);

      declare
         Process_Name : constant String
           := SOAP.Parameters.Get (Params, "Process_Name");
         Pid          : constant Integer
           := SOAP.Parameters.Get (Params, "Pid");
         Kill         : constant Boolean
           := SOAP.Parameters.Get (Params, "Kill");
      begin
         Remove_By_Pid                (Process_Name,
                 Pid,
                 Kill);
      end;

      SOAP.Message.Set_Parameters (Response, R_Params);
      return SOAP.Message.Response.Build (Response);
   exception
      when E : SOAP.Types.Data_Error =>
         --  Here we have a problem with some parameters, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Parameter error in Remove_By_Pid ("
                 & Exception_Message (E) & ")"));
      when O : others =>
         --  Here we have a problem with user's callback, return a SOAP error
         return SOAP.Message.Response.Build
           (SOAP.Message.Response.Error.Build
              (SOAP.Message.Response.Error.Client,
               "Error in Remove_By_Pid ("
                 & Exception_Message (O) & ")"));
   end Remove_By_Pid_CB;

end Dcod_Process_Launcher_Service.Server;
