with Ada.Strings;
with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with AWS.MIME;

with P42.Html_Utils;

with DCOD.Environment;
with Common_Types.Strings;
with Dcod_Process_Launcher;

package body Dcod_Launcher_Http is
   function Callback (Request : AWS.Status.Data) return AWS.Response.Data is
      URI : constant String := AWS.Status.URI (Request);
      Page : P42.Html_Utils.T_Page_Html;
   begin
      if URI = "/" then
         Page.Head (Title => "Launcher",
                    CSS_URI => "/css");
         Page.Append_Code ("<div class='entete'>");
         Page.Append_Code ("<h3>LAUNCHER RUNNING PROCESS</h3>");
         Page.Append_Code ("</div>");
         Page.Append_Code ("<div class='corps'>");
         declare
            Running_List : constant Common_Types.Strings.String_Couple_Array :=
              Dcod_Process_Launcher.Get_Running_List;
            Executable_List : constant Common_Types.Strings.String_Array :=
              Dcod_Process_Launcher.Get_Executable_List ("#ALL_DIRECTORIES#");
         begin
            if Running_List'Length = 0 then
               Page.Append_Code_Tagged ("p", "no process are running");
            else
               Page.Append_Code ("</br>");
               Page.Append_Code ("<table>");
               Page.Append_Code ("<caption><h3>Running process list :</h3></caption>");
               Page.Append_Code ("<tr>");
               Page.Append_Code ("<th>Running Name</th>");
               Page.Append_Code ("<th>PID</th>");
               Page.Append_Code ("</tr>");
               for Process of Running_List loop
                  Page.Append_Code ("<tr>");
                  Page.Append_Code ("<td>");
                  Page.Append_Code (To_String (Process.Name));
                  Page.Append_Code ("</td>");
                  Page.Append_Code ("<td>");
                  Page.Append_Code (To_String (Process.Value));
                  Page.Append_Code ("</td>");
                  Page.Append_Code ("</tr>");
               end loop;
               Page.Append_Code ("</table>");
               Page.Append_Code ("<br/>");
               Page.Append_Code ("<table>");
               Page.Append_Code ("<caption><h3>Executable list :</h3></caption>");
               Page.Append_Code ("<th>Executables</th>");
               for Executable of Executable_List loop
                  Page.Append_Code ("<tr>");
                  Page.Append_Code ("<td>");
                  Page.Append_Code (To_String (Executable));
                  Page.Append_Code ("</td>");
                  Page.Append_Code ("</tr>");
               end loop;
               Page.Append_Code ("</table>");
            end if;
         end;
         Page.Append_Code ("</div>");
         Page.Append_Code ("<div class='pied'>");
         Page.Append_Code ("<p class='title_pied'>Pied de page !</p>");
         Page.Append_Code ("</div>");
         return AWS.Response.Build ("text/html", Page.Return_Page);
      elsif URI = "/css" then
         return AWS.Response.File (AWS.MIME.Text_CSS, DCOD.Environment.CSS_Directory.all & "/dcod_global.css");
      end if;
      return AWS.Response.Build ("text/html", Page.Return_Page);
   end Callback;
end Dcod_Launcher_Http;
