with Ada.Text_IO;

with Broadcast_Stuff;
with Broadcast_Buffers;
with Broadcast_TLs;
with Passive_Directory;
with Utiles_Task;

procedure Broadcast_Listener is
   A_Task_Communication : aliased Utiles_Task.Task_Communication;
   A_Terminate_Task : Utiles_Task.Terminate_Task (A_Task_Communication'Access);
begin
   Passive_Directory.Start;
   loop
      select
         A_Task_Communication.Can_Stop;
         exit;
      else
         Passive_Directory.Directory.Set_Listen;
         Broadcast_Buffers.Ressource_Shell.Set_Listen;
         Broadcast_TLs.Ressource_Shell.Set_Listen;
         select
            Passive_Directory.Directory.Wait_For_Answer;
            declare
               Entries : constant Broadcast_Stuff.Process_Directory.Directory_Entry_Vectors.Vector :=
                 Passive_Directory.Directory.Get_Entries;
            begin
               Ada.Text_IO.Put_Line ("processes :" & Entries.Length'Img);
               for An_Entry of Entries loop
                  Ada.Text_IO.Put_Line (An_Entry.Kind'Img);
               end loop;
            end;
         or
            delay 0.5;
         end select;
         select
            Broadcast_Buffers.Ressource_Shell.Wait_For_Answer;
            declare
               Ressources : constant Broadcast_Stuff.Buffer_Ressource.Ressource_Vectors.Vector :=
                 Broadcast_Buffers.Ressource_Shell.Get_Ressources;
            begin
               Ada.Text_IO.Put_Line ("ressources :" & Ressources.Length'Img);
               for Ressource of Ressources loop
                  Ada.Text_IO.Put_Line ("BF ressource named : " & Broadcast_Stuff.Get_Name (Ressource));
               end loop;
            end;
         or
            delay 0.5;
         end select;
         select
            Broadcast_TLs.Ressource_Shell.Wait_For_Answer;
            declare
               Ressources : constant Broadcast_Stuff.TL_Ressource.Ressource_Vectors.Vector :=
                 Broadcast_TLs.Ressource_Shell.Get_Ressources;
            begin
               Ada.Text_IO.Put_Line ("ressources :" & Ressources.Length'Img);
               for Ressource of Ressources loop
                  Ada.Text_IO.Put_Line ("TL ressource named : " & Broadcast_Stuff.Get_Name (Ressource));
               end loop;
            end;
         or
            delay 0.5;
         end select;
      end select;
   end loop;
   Passive_Directory.Stop;
   Broadcast_Buffers.Close;
   Broadcast_TLs.Close;
end Broadcast_Listener;
