with Ada.Strings.Unbounded;
with Ada.Text_IO;

with Passive_Directory;
with Broadcast_Stuff;
with Dcod_Monitor_CB;

with AWS.Default;
with AWS.Server;
with AWS.Config.Set;

procedure Dcod_Monitor is

   WS : AWS.Server.HTTP;
   Config : AWS.Config.Object;

begin

   Ada.Text_IO.Put_Line
     ("Call me on port"
      & Positive'Image (AWS.Default.Server_Port));
   AWS.Config.Set.Max_Connection (Config, 1);
   AWS.Config.Set.Reuse_Address (Config, True);
   AWS.Config.Set.Server_Name (Config, "Dcod_Monitor");

   Passive_Directory.Start;
   Broadcast_Stuff.Set_Name (Passive_Directory.An_Entry, "dcod_monitor");
   Passive_Directory.Directory.Set_Listen;
   Passive_Directory.Directory.Ask_For_All;
   delay 0.1;
   declare
      Entries : constant Broadcast_Stuff.Process_Directory.Directory_Entry_Vectors.Vector :=
        Passive_Directory.Directory.Get_Entries;
   begin
      for An_Entry of Entries loop
         Ada.Text_IO.Put_Line (Ada.Strings.Unbounded.To_String (An_Entry.Name) & " " & An_Entry.Kind'Img);
      end loop;
   end;
   AWS.Server.Start (WS,
                     Callback => Dcod_Monitor_CB.Dcod_Mr_CB'Access,
                     Config => Config);
   AWS.Server.Wait (AWS.Server.Q_Key_Pressed);
   Passive_Directory.Stop;
exception
   when others =>
      Passive_Directory.Stop;
      raise;
end Dcod_Monitor;
