with Ada.Calendar.Formatting;
use Ada.Calendar.Formatting;
with Ada.Calendar.Time_Zones;
use Ada.Calendar.Time_Zones;
with Ada.Calendar; use Ada.Calendar;
with Ada.Strings.Unbounded;
with Ada.Strings;              use Ada.Strings;
with Ada.Strings.Fixed;        use Ada.Strings.Fixed;
with Passive_Directory;


package body Format_Page is

   function Redir_Page (Kind : Broadcast_Stuff.Process_Enum) return P42.Html_Utils.T_Page_Html is
      Page : P42.Html_Utils.T_Page_Html;
      Now : constant Time := Clock;
      Entries : Broadcast_Stuff.Process_Directory.Directory_Entry_Vectors.Vector :=
        Passive_Directory.Directory.Get_Entries;
      use type Broadcast_Stuff.Process_Enum;
      use Ada.Strings.Unbounded;
   begin
      Page.Head (Title => Kind'Img,
                 CSS_URI => "/css");
      Page.Append_Code ("<div class='entete'>");
      Page.Append_Code ("<p class='Title'>" & Kind'Img & "<br/></p></div>");
      Page.Append_Code ("<br/><br/>");
      Page.Append_Code ("<div class='corps_page'>");
      Page.Append_Code ("<table class='desc'>");
      Page.Append_Code ("<tr>");
      Page.Append_Code ("<caption><h3><u>Properties</u></h3></caption>");
      Page.Append_Code ("<br/><br/><td class='affiche'>Date~Hours :&nbsp;&nbsp;</td>"
                          & "<td class='value'>" & Image (Date => Now, Time_Zone => 1 * 60) & "</td>");
      Page.Append_Code ("</tr>");
      for This_Entry of Entries loop
         Page.Append_Code ("<tr>");
         if This_Entry.Kind = Kind then
            Page.Append_Code ("<td class='affiche'>");
            Page.Append_Code ("Name : </td>");
            Page.Append_Code ("<td class='value'>");
            Page.Append_Code ("<a href='http://" & This_Entry.Host & ":" &
                                Trim (Source => Positive'Image (This_Entry.Port),
                                      Side => Ada.Strings.Both) & "'target='_blank'>" &
                                This_Entry.Name & "</a></td></tr>");
            Page.Append_Code ("<tr>");
            Page.Append_Code ("</tr>");
            Page.Append_Code ("<td class='affiche'>Host : </td>");
            Page.Append_Code ("<td class='value'>" & This_Entry.Host & "</td>");
            Page.Append_Code ("</tr>");
            Page.Append_Code ("<tr>");
            Page.Append_Code ("<td class='affiche'>");
            Page.Append_Code ("Port :&nbsp;&nbsp;</td>");
            Page.Append_Code ("<td class='value'>" & Positive'Image (This_Entry.Port));
            Page.Append_Code ("</td>");
            Page.Append_Code ("</tr>");
         end if;
      end loop;
      Page.Append_Code ("<tr>");
      Page.Append_Code ("<td class='affiche'>Service is :&nbsp;&nbsp;</td><td class='value'>" &
                          "<img class='big' src='" &
                          "https://cdn3.iconfinder.com/data/icons/free-3d-glossy-" &
                          "interface-icon-set/32/OK.png'/></td>");
      Page.Append_Code ("</tr>");
      Page.Append_Code ("</table>");
      Page.Append_Code ("</div>");
      Page.Append_Code ("<div class='piedPage'>");
      Page.Append_Code ("<p class='TitlePied'>Pied de page ICI !</p></div>");
      return Page;
   end Redir_Page;

end Format_Page;
